#!/usr/bin/perl -w
# add match patterns to simp.log ...

# example input:
#   (FORALL (gridvar) (IMPLIES (AND (EQ (sel tag gridvar) Node_tag) (EQ (sel Node_color gridvar) C_GRAY2) (NEQ (sel Node_left gridvar) 0)) (EQ (sel Node_fwd (sel Node_left gridvar)) (sel Node_left (sel Node_fwd gridvar)))))
# and corresp. output:
#   (FORALL (gridvar) (PATS (MPAT (sel Node_fwd (sel Node_left gridvar)) (sel Node_fwd gridvar))
#                           (MPAT (sel Node_left (sel Node_fwd gridvar)) (sel Node_left gridvar)))
#                     (IMPLIES (AND (EQ (sel tag gridvar) Node_tag) (EQ (sel Node_color gridvar) C_GRAY2) (NEQ (sel Node_left gridvar) 0)) (EQ (sel Node_fwd (sel Node_left gridvar)) (sel Node_left (sel Node_fwd gridvar)))))

# some more:
#   (FORALL (gridvar) (IMPLIES (AND (EQ (sel tag_1 gridvar) Node_tag) (EQ (sel Node_color_2 gridvar) C_GRAY2) (NEQ (sel Node_left_1 gridvar) 0)) (EQ (sel Node_fwd_2 (sel Node_left_1 gridvar)) (sel Node_left_1 (sel Node_fwd_2 gridvar)))))
#   (FORALL (gridvar) (IMPLIES (AND (EQ (sel tag gridvar) Node_tag) (EQ (sel Node_color gridvar) C_BLACK) (NEQ (sel Node_left gridvar) 0)) (EQ (sel Node_fwd (sel Node_left gridvar)) (sel Node_left (sel Node_fwd gridvar)))))
#   (FORALL (gridvar) (IMPLIES (AND (EQ (sel tag gridvar) Node_tag) (EQ (sel Node_color gridvar) C_GRAY2) (NEQ (sel Node_left gridvar) 0)) (EQ (sel Node_fwd (sel Node_left gridvar)) (sel Node_left (sel Node_fwd gridvar))))) (FORALL (gridvar) (PATS (MPAT (sel Node_fwd (sel Node_left gridvar)) (sel Node_fwd gridvar)) (MPAT (sel Node_left (sel Node_fwd gridvar)) (sel Node_left gridvar))) (IMPLIES (AND (EQ (sel tag gridvar) Node_tag) (EQ (sel Node_color gridvar) C_BLACK) (NEQ (sel Node_left gridvar) 0)) (EQ (sel Node_fwd (sel Node_left gridvar)) (sel Node_left (sel Node_fwd gridvar)))))
#   (FORALL (gridvar) (IMPLIES (AND (EQ (sel tag gridvar) Node_tag) (EQ (sel Node_color gridvar) C_BLACK) (NEQ (sel Node_right gridvar) 0)) (EQ (sel Node_fwd (sel Node_right gridvar)) (sel Node_right (sel Node_fwd gridvar)))))


sub expand {
  my ($str) = @_;

  my ($before, $body, $fwd, $left, $after) = ($str =~
    m/^(.*)\(FORALL \(gridvar\) (\(IMPLIES \(AND \(EQ \(sel tag[^\)]* gridvar\) Node_tag[^\)]*\) \(EQ \(sel Node_color[^\)]* gridvar\) C_[^\)]*\) \(NEQ \(sel Node_[^\)]* gridvar\) 0\)\) \(EQ \(sel (Node_fwd[^\)]*) \(sel (Node_[^\)]*) gridvar\)\) \(sel Node_[^\)]* \(sel Node_fwd[^\)]* gridvar\)\)\)\))\)(.*)$/);
  if (defined($left)) {
    #print("; fwd: $fwd\n");
    #print("; left: $left\n");
    #print("; body: $body\n");
    expand($before);
    print("(FORALL (gridvar) (PATS (MPAT (sel $fwd (sel $left gridvar)) (sel $fwd gridvar))" .
                                 " (MPAT (sel $left (sel $fwd gridvar)) (sel $left gridvar))) $body)");
    expand($after);
  }
  else {
    print($str);
  }
}

while (defined($line = <STDIN>)) {
  chomp($line);
  expand($line);
  print("\n");
}




# EOF
