// c2v_lexer.h            see license.txt for copyright and terms of use
// lexer for C2V source files
// adapted from elsa/lexer.h

#ifndef C2V_LEXER_H
#define C2V_LEXER_H

#include "vml_lexer.h"      // VMLLexer
#include "c2v_tokens.h"     // C2VToken
#include "ccsstr.h"         // CCSubstrate


char const *toString(C2VToken type);


// lexer object
class C2VLexer : public VMLLexer {
protected:  // data
  // embedded state
  bool recentMatchKeyword; // recently seen a keyword that starts embedded?
  SourceLoc embedStartLoc; // location of start of embedded sequence
  char embedStart;         // character at start of embedded sequence
  char embedFinish;        // character expected at end
  CCSubstrate *embedded;   // machine to scan for end of embedded sequence

protected:  // funcs
  FLEX_OUTPUT_METHOD_DECLS

public:     // funcs
  // make a lexer to scan the given file
  C2VLexer(StringTable &strtable, char const *fname);
  ~C2VLexer();

  // LexerInterface funcs
  virtual string tokenDesc() const;
  virtual string tokenKindDesc(int kind) const;
};


#endif // C2V_LEXER_H
