(* subsumption.v *)
(* proof of a fact used (sometimes) by Simplify *)

(* interesting to note that Tauto can't prove this, even though
 * trying all 8 possible truth assignments would work *)

Section Subsumption.

Require Classical.

Theorem subsumption : (P,Q,R:Prop)
  (P -> R) ->             (* since P->R, *)
  ((~P /\ Q) -> R) ->     (* we can assume ~P while trying to prove Q->R *)
  ((P \/ Q) -> R).
Proof.
Intros P Q R.
Intros Hp Hnpq.
Assert Em : P \/ ~P.
Apply classic.            (* from Classical *)
Elim Em.

(* if P *)
Intros.
Apply Hp.
Assumption.

(* if ~P *)
Intros.
Elim H0.
Intro.
Absurd P.
Assumption.
Assumption.
Intro.
Apply Hnpq.
Auto.
Save.



(* what is this called?  did I call the wrong thing "subsumption"? *)
Theorem another : (P,Q,R:Prop)
  ((P->R) \/              (* if we try the obvious thing and it doesn't work, *)
   ((P /\ ~Q) -> R)) ->   (* then try the other one, but assume ~Q *)
  (P -> (Q \/ R)).
Proof.
Intros P Q R.
Intros.
Elim H.

(* case: P->R *)
Intro.
Right.
Apply H1.
Assumption.

(* case: (P /\ ~Q) -> R
Intro.
Assert Em : Q \/ ~Q.      (* from Classical *)
Apply classic.
Elim Em.

(* case: Q *)
Intro.
Left.
Assumption.

(* case: ~Q *)
Intro.
Right.
Apply H1.
Split.
Assumption.
Assumption.
Save.


End Subsumption.

(* EOF *)
