// array1.c
// simple array

// --------- verifier preamble ----------
#include "ptr.model"     // sel/upd/ptr
#include "state.model"   // metaVar

// C functions that are modeled directly
void *malloc(int size);
void free(void *ptr);


// ----------------- code to verify ---------------
int global_inv() { return vc_expression(all_of {
  objct > 0;
});}


void f()
  changes(mem, meta, tag, objsize, objct)
{
  //void * /*owner*/ v = malloc(10 * sizeof(int));

  // v is an owner pointer to 40 deadbytes

  int * /*owner*/ a __varattribute__((array)) = (int*)malloc(10 * sizeof(int));

  int i;

  // v is dead
  // a is an owner pointer to 10 dead integers
  assert(objsize[a] == 10);
  //assert(metaVar(a) == live);

  for (i=0; i<10; i++) {
    invariant {
      0 < a < objct;
      //metaVar(a) == live;
      objsize[a] == 10;
      0 <= i < 10;
      forall(int j) PATS(meta[a,j]). 
        0<=j<i ==> meta[a,j]==live;
    }

    // a is an owner pointer to 10 integers
    // for 0<=j<i, a[j] is not dead

    a[i] = i;
  }

  // a is an owner pointer to 10 live integers

  int sum = 0;
  for (i=0; i<10; i++) {
    invariant {
      0 < a < objct;
      //metaVar(a) == live;
      objsize[a] == 10;
      0 <= i < 10;
      forall(int j) PATS(meta[a,j]). 
        0<=j<10 ==> meta[a,j]==live;
    }

    sum += a[i];          // ok, a[i] not dead
  }                                           
  
  free(a);                // ok, live int is subtype of dead int
  
  //ERROR(1): a[5] = 5;   // use after free
}


/*
  Errors to catch:
    - malloc'ing too few bytes
    - failing to init all of the integers
    - init'ing off the end of the array
*/
