// mark.c
// mark phase of a garbage collector
// modified from tvla/examples/gc/mark.tvp




// @Ensures marked == REACH(root)
void Mark(Node root, NodeSet marked) {
  Node x;
  if (root != null) {

    pending.clear();
    pending.add(root);
    marked.clear();
    while (!pending.isEmpty()) {

      // crucial invariant:
      //   every reachable white node has a gray ancestor

      x = pending.selectAndRemove();
      marked.add(x);
      t = x.left;
      if (t != null) {

        if (!marked.contains(t)) {

          pending.add(t)
        }
      }
      t = null;
      t = x.right;
      if (t != null) {

        if (!marked.contains(t)) {

          pending.add(t)
        }
      }
      t = null;
   }

   if (marked.SetNotEqualReachset(root)) {
     System.err.println("Internal error: mark phase of gc")
   }

  }
}

