// prv_ket.h
// implementation of ProverInterface that works with Kettle

#ifndef PRV_KET_H
#define PRV_KET_H

#include "prv_int.h"   // ProverInterface
#include "smregexp.h"  // Regexp

class KettleInterface : public ProverInterface {
private:     // data
  // regexps for specific situations
  Regexp respValid, respInvalid;

public:      // funcs
  KettleInterface();
  virtual ~KettleInterface();

  // implementations of ProverInterface functions
  virtual ReadAction analyzeInitialPrompt(rostring response);
  virtual string getLogfileHeader(rostring fname);
  virtual ReadAction analyzeGoalResponse(rostring response);
  //virtual void afterProofCheck(rostring response);
  virtual string extractCounterexample(rostring response);
};

#endif // PRV_KET_H
