// addrglobal.c
// example where the address of a global is used in the
// same way as something that comes from malloc


// --------- verifier preamble ----------
// for now, use asm hack to put the includes in
asm("verifier: include \"ptr.vc\";");
asm("verifier: include \"state.vc\";");

// C functions that are modeled directly
void *malloc(int size);
void free(void *ptr);

// declarations of model functions
int sel(int mem, int p);
int ptr(int addr, int field);

// need to somehow say this is a constant symbolic value, not a global..
// let's try 'const'
int const dead;
int const live;
//int const state;

// more or less true globals
//int mem;
//int meta;
int tag;
int objsize;    // map from toplevel addresses to sizes
int objct;

// separator between in-memory globals and the heap
int heapStart;



// -------------------- code to verify ------------------
typedef struct Foo {
  int x;
  int y;
} Foo;

Foo global_Foo __varattribute__((addrtaken));


// global invariant
int global_inv() { return vc_expression(all_of {
  0 < heapStart < objct;
  0 < /*&*/global_Foo < heapStart;
  tag[/*&*/global_Foo] == Foo_tag;
});}


int addXY(Foo *f)
  pre(0 < f && tag[f]==Foo_tag)
{
  return f->x + f->y;
}


void func()
  changes(objct, objsize, tag, Foo_tag)
{ 
  global_Foo.x = 5;            // read field
  int z = global_Foo.y;        // write field

  addXY(&global_Foo);          // use address

  assert(Foo_x[global_Foo]==5);
  assert(z==Foo_y[global_Foo]);

  struct Foo *f = (struct Foo*)malloc(sizeof(Foo));
  f->x = f->y = 6;
  addXY(f);
  free(f);        

  //free(&global_Foo);    // oops! this *is* caught by the verifier.  :)
}


