// funcall.c
// experimenting with function calls, pre/post, etc.


// ---------------- verifier preamble --------------
// more or less true globals
int mem;
//int meta;
//int objct;


// -------------- code to verify -------------
// more globals
int x;
int y;


int global_inv() { return vc_expression(all_of {
  1==1;       // "true"
});}


// modifies nothing, no pre/post
void noop();


// modifies nothing, but reliably returns 3
int three()
  post(result == 3)
{
  return 3;
}


// increments x
void incx()
  post(x == pre(x)+1)     // pre(x) refers to x in the pre-state
  changes(x)
{
  x = x+1;
}


// increments x by some positive amount
void addx(int amt)
  pre(amt > 0)
  post(x > pre(x))        // deliberate underspecification
  changes(x)
{
  x = x + amt;
}


void main()
  changes(x,y)
{
  x = three();
  y = 4;

  assert(x==3 && y==4);

  noop();

  assert(x==3 && y==4);

  incx();

  assert(x==4 && y==4);

  addx(2);

  assert(x>4 && y==4);

  addx(x);

  assert(x>4 && y==4);
}


// EOF
